package com.xiaoniu.subsystem.business.controller;

import com.alibaba.nacos.common.utils.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.xiaoniu.common.core.result.R;
import com.xiaoniu.common.core.utils.BeanUtil;
import com.xiaoniu.common.core.utils.poi.ExcelUtil;
import com.xiaoniu.common.log.annotation.Log;
import com.xiaoniu.common.log.enums.BusinessType;
import com.xiaoniu.subsystem.business.domain.CheckBedroom;
import com.xiaoniu.subsystem.business.domain.ExamQuestion;
import com.xiaoniu.subsystem.business.domain.Flight;
import com.xiaoniu.subsystem.business.domain.dto.ExamQuestionDTO;
import com.xiaoniu.subsystem.business.domain.dto.ExamQuestionPageDTO;
import com.xiaoniu.subsystem.business.domain.vo.ExamQuestionPageVO;
import com.xiaoniu.subsystem.business.domain.vo.ExamQuestionVO;
import com.xiaoniu.subsystem.business.service.IExamQuestionService;
import com.xiaoniu.subsystem.business.service.IFlightService;
import com.xiaoniu.subsystem.system.domain.Unit;
import com.xiaoniu.subsystem.system.service.IUnitService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import static com.xiaoniu.common.security.utils.SecurityUtils.getUnitId;
import static com.xiaoniu.common.security.utils.SecurityUtils.getUserId;

/**
 * <p>
 * 考试题库表 前端控制器
 * </p>
 *
 * @author haoxuyang
 * @since 2024-12-23 05:36:11
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("/examQuestion")
@Tag(name = "考试题库表", description = "考试题库")
public class ExamQuestionController {
    private final IExamQuestionService examQuestionService;
    private final IUnitService unitService;




    /**
     * 详情
     */
    @GetMapping("/detail")
    @ApiOperationSupport(order = 1)
    @Operation(summary = "详情", description = "传入questionId")
    public R<ExamQuestionVO> detail(@Parameter(description = "主键", required = true) @RequestParam Long questionId) {
        ExamQuestion detail = examQuestionService.getById(questionId);
        return R.data(BeanUtil.copy(detail, ExamQuestionVO.class));
    }

    /**
     * 分页 考试题库表
     */
    @GetMapping("/page")
    @ApiOperationSupport(order = 2)
    @Operation(summary = "分页", description = "传入examQuestion")
    public R<IPage<ExamQuestionPageVO>> page(@Validated ExamQuestionPageDTO dto) {
        IPage<ExamQuestion> pages = examQuestionService.page(new Page<>(dto.getPageNum(), dto.getPageSize()),
                new LambdaQueryWrapper<ExamQuestion>()
                        .orderByDesc(ExamQuestion::getCreateTime)
                        .eq(null != getUnitId() && 0 == getUnitId(),ExamQuestion::getCreateDept,getUnitId())
                        .eq(StringUtils.isNotBlank(dto.getFlightId()), ExamQuestion::getFlightId,dto.getFlightId())
                        .eq(StringUtils.isNotBlank(dto.getQuestionType()), ExamQuestion::getQuestionType, dto.getQuestionType())
                        .like(StringUtils.isNotBlank(dto.getQuestion()), ExamQuestion::getQuestion, dto.getQuestion())
                        );
        IPage<ExamQuestionPageVO> copy = BeanUtil.copy(pages, ExamQuestionPageVO.class);
        return R.data(copy);
    }

    /**
     * 新增 考试题库表
     */
    @PostMapping("/save")
    @ApiOperationSupport(order = 4)
    @Operation(summary = "新增", description = "传入examQuestion")
    public R save(@Valid @RequestBody ExamQuestionDTO dto) {
        Unit unit = unitService.getById(getUnitId());
        ExamQuestion copy = BeanUtil.copy(dto, ExamQuestion.class)
                .setCreateDept(unit.getUnitId())
                .setCreateUser(getUserId())
                .setCreateTime(new Date());
        List<ExamQuestion> one = examQuestionService.list(new LambdaQueryWrapper<ExamQuestion>()
                .eq(ExamQuestion::getQuestion,copy.getQuestion())
                .eq(ExamQuestion::getFlightId,copy.getFlightId())
        );
        if (CollectionUtils.isNotEmpty(one)) {
            return R.fail("题干已存在");
        }
        return R.status(examQuestionService.save(copy));
    }


    /**
     * 修改 考试题库表
     */
    @PostMapping("/update")
    @ApiOperationSupport(order = 5)
    @Operation(summary = "修改", description = "传入examQuestion")
    public R update(@Valid @RequestBody ExamQuestionDTO dto) {
        ExamQuestion copy = BeanUtil.copy(dto, ExamQuestion.class)
                .setUpdateUser(getUserId())
                .setUpdateTime(new Date());
        return R.status(examQuestionService.updateById(copy));
    }

    /**
     * 删除 考试题库表
     */
    @PostMapping("/remove")
    @ApiOperationSupport(order = 7)
    @Operation(summary = "删除", description = "传入ids")
    public R remove(@Parameter(description = "主键集合", required = true) @RequestParam String ids) {
        List<ExamQuestion> list = examQuestionService.listByIds(Arrays.stream(ids.split(",")).toList());
        return R.status(examQuestionService.removeByIds(Arrays.stream(ids.split(",")).toList()));
    }

    /**
     * 导出
     */
    @GetMapping("/export")
    @ApiOperationSupport(order = 3)
    @Log(title = "导出", businessType = BusinessType.EXPORT)
    @Operation(summary = "导出", description = "传入ExamQuestionPageDTO")
    public void export(HttpServletResponse response, @Validated ExamQuestionPageDTO dto) {
        List<ExamQuestion> list = new ArrayList<>();
        if (StringUtils.isNotBlank(dto.getIds())) {
            list.addAll(examQuestionService.list(new LambdaQueryWrapper<ExamQuestion>()
                    .orderByDesc(ExamQuestion::getCreateTime)
                    .in(StringUtils.isNotBlank(dto.getIds()), ExamQuestion::getQuestionId,
                            Arrays.stream(dto.getIds().split(",")).toList())));
        } else {
            list.addAll(examQuestionService.list(new LambdaQueryWrapper<ExamQuestion>()
                    .orderByDesc(ExamQuestion::getCreateTime)
                    .eq(ExamQuestion::getFlightId,dto.getFlightId())
                    .eq(StringUtils.isNotBlank(dto.getQuestionType()), ExamQuestion::getQuestionType, dto.getQuestionType())
                    .like(StringUtils.isNotBlank(dto.getQuestion()), ExamQuestion::getQuestion, dto.getQuestion())));
        }
        ExcelUtil<ExamQuestion> excelUtil = new ExcelUtil<>(ExamQuestion.class);
        excelUtil.exportExcel(response, list, "考试题库数据");

    }


    /**
     * 导入
     */
    @PostMapping("/import")
    @ApiOperationSupport(order = 9)
    @Log(title = "考试题库导入", businessType = BusinessType.IMPORT)
    @Operation(summary = "导入")
    public R importData(MultipartFile file,
                        @Parameter(description = "是否支持更新", required = true)
                        @RequestParam boolean updateSupport) throws Exception {
        ExcelUtil<ExamQuestion> util = new ExcelUtil<>(ExamQuestion.class);
        List<ExamQuestion> list = util.importExcel(file.getInputStream());
        return R.success(examQuestionService.importData(list, updateSupport));
    }

    /**
     * 模版导入
     */
    @GetMapping("/importTemplate")
    @ApiOperationSupport(order = 10)
    @Operation(summary = "导入模版下载")
    public void importTemplate(HttpServletResponse response) {
        ExcelUtil<ExamQuestion> util = new ExcelUtil<>(ExamQuestion.class);
        util.importTemplateExcel(response, "考试题库导入模版");
    }
}
